import * as squint_core from 'squint-cljs/core.js';
import * as commands from '@codemirror/commands';
import * as u from './util.mjs';
import * as sel from './selections.mjs';
import * as n from './node.mjs';
import * as format from './extensions/formatting.mjs';
import * as sel_history from './extensions/selection_history.mjs';
var view_command = (function (f) {
return function (p__115) {
let map__12 = p__115;
let state3 = squint_core.get(map__12, "state");
let dispatch4 = squint_core.get(map__12, "dispatch");
let G__1165 = f(state3);
if ((G__1165 == null)) {
null} else {
dispatch4(G__1165)};
return true
}
});
var scoped_view_command = (function (f) {
return function (p__117) {
let map__12 = p__117;
let state3 = squint_core.get(map__12, "state");
let dispatch4 = squint_core.get(map__12, "dispatch");
if (squint_core.truth_(n.within_program_QMARK_(state3))) {
let G__1185 = f(state3);
if ((G__1185 == null)) {
null} else {
dispatch4(G__1185)};
return true} else {
return false}
}
});
var unwrap_STAR_ = (function (state) {
return u.update_ranges(state, (function (p__119) {
let map__12 = p__119;
let range3 = map__12;
let from4 = squint_core.get(map__12, "from");
let to5 = squint_core.get(map__12, "to");
let empty6 = squint_core.get(map__12, "empty");
if (squint_core.truth_(empty6)) {
let temp__27165__auto__7 = (function () {
 let G__1208 = n.tree(state, from4, -1);
let G__1209 = ((G__1208 == null)) ? (null) : (n.closest(G__1208, n.coll_QMARK_));
if ((G__1209 == null)) {
return null} else {
return u.guard(G__1209, n.balanced_QMARK_)}
})();
if (squint_core.truth_(temp__27165__auto__7)) {
let nearest_balanced_coll10 = temp__27165__auto__7;
return ({ "cursor": (from4 - 1), "changes": [n.from_to(n.down(nearest_balanced_coll10)), n.from_to(n.down_last(nearest_balanced_coll10))] })}}
}))
});
var copy_to_clipboard_BANG_ = (function (text) {
let focus_el1 = squint_core.get(document, "activeElement");
let input_el2 = document.createElement("textarea");
input_el2.setAttribute("class", "clipboard-input");
squint_core.assoc_BANG_(input_el2, "innerHTML", text);
document.body.appendChild(input_el2);
input_el2.focus(({ "preventScroll": true }));
input_el2.select();
document.execCommand("copy");
focus_el1.focus(({ "preventScroll": true }));
return document.body.removeChild(input_el2)
});
var kill_STAR_ = (function (state) {
return u.update_ranges(state, (function (p__121) {
let map__12 = p__121;
let range3 = map__12;
let from4 = squint_core.get(map__12, "from");
let to5 = squint_core.get(map__12, "to");
let empty6 = squint_core.get(map__12, "empty");
if (squint_core.truth_(empty6)) {
let node7 = n.tree(state, from4);
let parent8 = n.closest(node7, (function (_PERCENT_1) {
let or__27578__auto__9 = n.coll_QMARK_(_PERCENT_1);
if (squint_core.truth_(or__27578__auto__9)) {
return or__27578__auto__9} else {
let or__27578__auto__10 = n.string_QMARK_(_PERCENT_1);
if (squint_core.truth_(or__27578__auto__10)) {
return or__27578__auto__10} else {
return n.top_QMARK_(_PERCENT_1)}}
}));
let line_end11 = state.doc.lineAt(from4).to;
let next_children12 = (squint_core.truth_(parent8)) ? (n.children(parent8, from4, 1)) : (null);
let last_child_on_line13 = (squint_core.truth_(parent8)) ? ((function () {
 let G__12214 = next_children12;
let G__12215 = ((G__12214 == null)) ? (null) : (squint_core.take_while(squint_core.every_pred((function (_PERCENT_1) {
return (n.start(_PERCENT_1) <= line_end11)
})), G__12214));
if ((G__12215 == null)) {
return null} else {
return squint_core.last(G__12215)}
})()) : (null);
let to16 = (squint_core.truth_(n.string_QMARK_(parent8))) ? ((function () {
 let content17 = squint_core.str(n.string(state, parent8));
let content_from18 = squint_core.subs(content17, (from4 - n.start(parent8)));
let next_newline19 = content_from18.indexOf("\n");
if ((next_newline19 < 0)) {
return (n.end(parent8) - 1)} else {
return (from4 + next_newline19 + 1)}
})()) : ((squint_core.truth_(last_child_on_line13)) ? ((squint_core.truth_(n.end_edge_QMARK_(last_child_on_line13))) ? (n.start(last_child_on_line13)) : (n.end(last_child_on_line13))) : ((squint_core.truth_((function () {
 let G__12320 = squint_core.first(next_children12);
let G__12321 = ((G__12320 == null)) ? (null) : (n.start(G__12320));
if ((G__12321 == null)) {
return null} else {
return (G__12321 > line_end11)}
})())) ? (n.start(squint_core.first(next_children12))) : (null)));
if (squint_core.truth_(u.node_js_QMARK_)) {
null} else {
copy_to_clipboard_BANG_(n.string(state, from4, to16))};
if (squint_core.truth_(to16)) {
return ({ "cursor": from4, "changes": ({ "from": from4, "to": to16 }) })}} else {
copy_to_clipboard_BANG_(n.string(state, from4, to5));
return ({ "cursor": from4, "changes": u.from_to(from4, to5) })}
}))
});
var enter_and_indent_STAR_ = (function (state) {
let ctx1 = format.make_indent_context(state);
return u.update_ranges(state, (function (p__124) {
let map__23 = p__124;
let range4 = map__23;
let from5 = squint_core.get(map__23, "from");
let to6 = squint_core.get(map__23, "to");
let empty7 = squint_core.get(map__23, "empty");
let indent_at8 = (function () {
 let G__1259 = n.closest(n.tree(state, from5), squint_core.some_fn(n.coll_QMARK_, n.top_QMARK_));
let G__12510 = ((G__1259 == null)) ? (null) : (n.inner_span(G__1259));
if ((G__12510 == null)) {
return null} else {
return n.start(G__12510)}
})();
let indent11 = (squint_core.truth_(indent_at8)) ? (format.get_indentation(ctx1, indent_at8)) : (null);
let insertion12 = squint_core.str("\n", (squint_core.truth_(indent11)) ? (format.spaces(state, indent11)) : (null));
return ({ "cursor": (from5 + squint_core.count(insertion12)), "changes": [({ "from": from5, "to": to6, "insert": insertion12 })] })
}))
});
var nav_position = (function (state, from, dir) {
let or__27578__auto__1 = (function () {
 let G__1262 = n.closest(n.tree(state, from), (function (_PERCENT_1) {
let or__27578__auto__3 = n.coll_QMARK_(_PERCENT_1);
if (squint_core.truth_(or__27578__auto__3)) {
return or__27578__auto__3} else {
let or__27578__auto__4 = n.string_QMARK_(_PERCENT_1);
if (squint_core.truth_(or__27578__auto__4)) {
return or__27578__auto__4} else {
return n.top_QMARK_(_PERCENT_1)}}
}));
let G__1265 = ((G__1262 == null)) ? (null) : (n.children(G__1262, from, dir));
let G__1266 = ((G__1265 == null)) ? (null) : (squint_core.first(G__1265));
if ((G__1266 == null)) {
return null} else {
return squint_core.get(G__1266, (function () {
 let G__1277 = dir;
switch (G__1277) {case -1:
return "from"
break;
case 1:
return "to"
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__1277))}
})())}
})();
if (squint_core.truth_(or__27578__auto__1)) {
return or__27578__auto__1} else {
return sel.constrain(state, (from + dir))}
});
var nav = (function (dir) {
return function (state) {
return u.update_ranges(state, (function (p__128) {
let map__12 = p__128;
let range3 = map__12;
let from4 = squint_core.get(map__12, "from");
let to5 = squint_core.get(map__12, "to");
let empty6 = squint_core.get(map__12, "empty");
if (squint_core.truth_(empty6)) {
return ({ "cursor": nav_position(state, from4, dir) })} else {
return ({ "cursor": squint_core.get(u.from_to(from4, to5), (function () {
 let G__1297 = dir;
switch (G__1297) {case -1:
return "from"
break;
case 1:
return "to"
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__1297))}
})()) })}
}))
}
});
var nav_select = (function (dir) {
return function (state) {
return u.update_ranges(state, (function (p__130) {
let map__12 = p__130;
let range3 = map__12;
let from4 = squint_core.get(map__12, "from");
let to5 = squint_core.get(map__12, "to");
let empty6 = squint_core.get(map__12, "empty");
if (squint_core.truth_(empty6)) {
return ({ "range": n.balanced_range(state, from4, nav_position(state, from4, dir)) })} else {
return ({ "range": (function () {
 let map__78 = u.from_to(from4, to5);
let from9 = squint_core.get(map__78, "from");
let to10 = squint_core.get(map__78, "to");
let G__13111 = dir;
switch (G__13111) {case 1:
return n.balanced_range(state, from9, nav_position(state, to10, dir))
break;
case -1:
return n.balanced_range(state, nav_position(state, from9, dir), to10)
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__13111))}
})() })}
}))
}
});
var balance_ranges = (function (state) {
return u.update_ranges(state, (function (p__132) {
let map__12 = p__132;
let from3 = squint_core.get(map__12, "from");
let to4 = squint_core.get(map__12, "to");
let empty5 = squint_core.get(map__12, "empty");
if (squint_core.truth_(empty5)) {
return null} else {
return ({ "range": n.balanced_range(state, from3, to4) })}
}))
});
var log = console.log;
var slurp = (function (direction) {
return function (state) {
return u.update_ranges(state, (function (p__133) {
let map__12 = p__133;
let range3 = map__12;
let from4 = squint_core.get(map__12, "from");
let to5 = squint_core.get(map__12, "to");
let empty6 = squint_core.get(map__12, "empty");
if (squint_core.truth_(empty6)) {
let temp__27165__auto__7 = n.closest(n.tree(state, from4), squint_core.every_pred(n.coll_QMARK_, (function (_PERCENT_1) {
return squint_core.not((function () {
 let G__1348 = direction;
switch (G__1348) {case 1:
let G__13510 = _PERCENT_1;
let G__13511 = ((G__13510 == null)) ? (null) : (n.with_prefix(G__13510));
let G__13512 = ((G__13511 == null)) ? (null) : (n.right(G__13511));
if ((G__13512 == null)) {
return null} else {
return n.end_edge_QMARK_(G__13512)}
break;
case -1:
let G__13613 = _PERCENT_1;
let G__13614 = ((G__13613 == null)) ? (null) : (n.with_prefix(G__13613));
let G__13615 = ((G__13614 == null)) ? (null) : (n.left(G__13614));
if ((G__13615 == null)) {
return null} else {
return n.start_edge_QMARK_(G__13615)}
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__1348))}
})())
})));
if (squint_core.truth_(temp__27165__auto__7)) {
let parent16 = temp__27165__auto__7;
let temp__27165__auto__17 = (function () {
 let G__13718 = direction;
switch (G__13718) {case 1:
return squint_core.first(squint_core.remove(n.line_comment_QMARK_, n.rights(n.with_prefix(parent16))))
break;
case -1:
return squint_core.first(squint_core.remove(n.line_comment_QMARK_, n.lefts(n.with_prefix(parent16))))
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__13718))}
})();
if (squint_core.truth_(temp__27165__auto__17)) {
let target20 = temp__27165__auto__17;
return ({ "cursor/mapped": from4, "changes": (function () {
 let G__13821 = direction;
switch (G__13821) {case 1:
let edge23 = n.down_last(parent16);
return [({ "from": n.end(target20), "insert": n.name(edge23) }), squint_core.assoc_BANG_(n.from_to(edge23), "insert", " ")]
break;
case -1:
let edge24 = n.left_edge_with_prefix(state, parent16);
let start25 = n.start(n.with_prefix(parent16));
return [({ "from": start25, "to": (start25 + squint_core.count(edge24)), "insert": " " }), ({ "from": n.start(target20), "insert": edge24 })]
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__13821))}
})() })}}}
}))
}
});
var barf = (function (direction) {
return function (state) {
return u.update_ranges(state, (function (p__139) {
let map__12 = p__139;
let range3 = map__12;
let from4 = squint_core.get(map__12, "from");
let to5 = squint_core.get(map__12, "to");
let empty6 = squint_core.get(map__12, "empty");
if (squint_core.truth_(empty6)) {
let temp__27165__auto__7 = n.closest(n.tree(state, from4), n.coll_QMARK_);
if (squint_core.truth_(temp__27165__auto__7)) {
let parent8 = temp__27165__auto__7;
let G__1409 = direction;
switch (G__1409) {case 1:
let temp__27165__auto__11 = (function () {
 let G__14112 = n.down_last(parent8);
let G__14113 = ((G__14112 == null)) ? (null) : (n.lefts(G__14112));
let G__14114 = ((G__14113 == null)) ? (null) : (squint_core.remove(n.line_comment_QMARK_, G__14113));
let G__14115 = ((G__14114 == null)) ? (null) : (squint_core.drop(1, G__14114));
if ((G__14115 == null)) {
return null} else {
return squint_core.first(G__14115)}
})();
if (squint_core.truth_(temp__27165__auto__11)) {
let target16 = temp__27165__auto__11;
return ({ "cursor": squint_core.min(n.end(target16), from4), "changes": [({ "from": n.end(target16), "insert": n.name(n.down_last(parent8)) }), squint_core.assoc_BANG_(n.from_to(n.down_last(parent8)), "insert", " ")] })}
break;
case -1:
let temp__27165__auto__17 = (function () {
 let G__14218 = n.down(parent8);
let G__14219 = ((G__14218 == null)) ? (null) : (n.rights(G__14218));
let G__14220 = ((G__14219 == null)) ? (null) : (squint_core.remove(n.line_comment_QMARK_, G__14219));
let G__14221 = ((G__14220 == null)) ? (null) : (squint_core.drop(1, G__14220));
if ((G__14221 == null)) {
return null} else {
return squint_core.first(G__14221)}
})();
if (squint_core.truth_(temp__27165__auto__17)) {
let next_first_child22 = temp__27165__auto__17;
let left_edge23 = n.left_edge_with_prefix(state, parent8);
let left_start24 = n.start(n.with_prefix(parent8));
return ({ "cursor": squint_core.max(from4, (n.start(next_first_child22) + (squint_core.count(left_edge23) + 1))), "changes": [({ "from": n.start(next_first_child22), "insert": squint_core.str(" ", left_edge23) }), ({ "from": left_start24, "to": (left_start24 + squint_core.count(left_edge23)), "insert": format.spaces(state, squint_core.count(left_edge23)) })] })}
break;
default:
throw new Error(squint_core.str("No matching clause: ", G__1409))}}}
}))
}
});
var builtin_index = ({ "cursorLineStart": commands.cursorLineStart, "cursorLineDown": commands.cursorLineDown, "selectAll": commands.selectAll, "selectLineUp": commands.selectLineUp, "cursorLineBoundaryForward": commands.cursorLineBoundaryForward, "selectLineBoundaryBackward": commands.selectLineBoundaryBackward, "deleteCharBackward": commands.deleteCharBackward, "insertNewlineAndIndent": commands.insertNewlineAndIndent, "cursorLineBoundaryBackward": commands.cursorLineBoundaryBackward, "selectCharRight": commands.selectCharRight, "selectPageUp": commands.selectPageUp, "deleteCharForward": commands.deleteCharForward, "cursorCharLeft": commands.cursorCharLeft, "cursorGroupBackward": commands.cursorGroupBackward, "selectDocStart": commands.selectDocStart, "selectGroupBackward": commands.selectGroupBackward, "cursorDocEnd": commands.cursorDocEnd, "deleteGroupBackward": commands.deleteGroupBackward, "selectLineStart": commands.selectLineStart, "deleteGroupForward": commands.deleteGroupForward, "selectDocEnd": commands.selectDocEnd, "selectPageDown": commands.selectPageDown, "cursorPageDown": commands.cursorPageDown, "cursorPageUp": commands.cursorPageUp, "selectLineBoundaryForward": commands.selectLineBoundaryForward, "cursorLineEnd": commands.cursorLineEnd, "cursorGroupForward": commands.cursorGroupForward, "cursorCharRight": commands.cursorCharRight, "selectGroupForward": commands.selectGroupForward, "selectLineEnd": commands.selectLineEnd, "selectCharLeft": commands.selectCharLeft, "splitLine": commands.splitLine, "selectLineDown": commands.selectLineDown, "transposeChars": commands.transposeChars, "cursorLineUp": commands.cursorLineUp, "cursorDocStart": commands.cursorDocStart });
var indent = view_command(format.format);
var unwrap = view_command(unwrap_STAR_);
var kill = scoped_view_command(kill_STAR_);
var nav_right = view_command(nav(1));
var nav_left = view_command(nav(-1));
var nav_select_right = view_command(nav_select(1));
var nav_select_left = view_command(nav_select(-1));
var slurp_forward = view_command(slurp(1));
var slurp_backward = view_command(slurp(-1));
var barf_forward = view_command(barf(1));
var barf_backward = view_command(barf(-1));
var selection_grow = view_command(sel_history.selection_grow_STAR_);
var selection_return = view_command(sel_history.selection_return_STAR_);
var enter_and_indent = view_command(enter_and_indent_STAR_);
var paredit_index = ({ "indent": indent, "nav-left": nav_left, "enter-and-indent": enter_and_indent, "selection-grow": selection_grow, "kill": kill, "slurp-forward": slurp_forward, "nav-select-right": nav_select_right, "nav-select-left": nav_select_left, "barf-forward": barf_forward, "barf-backward": barf_backward, "nav-right": nav_right, "slurp-backward": slurp_backward, "unwrap": unwrap, "selection-return": selection_return });
var index = squint_core.merge(builtin_index, paredit_index);
var reverse_index = squint_core.reduce_kv((function (_PERCENT_1, _PERCENT_2, _PERCENT_3) {
return squint_core.assoc(_PERCENT_1, _PERCENT_3, _PERCENT_2)
}), ({  }), index);

export { nav_select_left, index, view_command, barf_backward, scoped_view_command, kill_STAR_, enter_and_indent_STAR_, unwrap, enter_and_indent, log, nav_select, slurp, nav_position, indent, nav_select_right, slurp_forward, selection_grow, nav, balance_ranges, nav_left, copy_to_clipboard_BANG_, barf, builtin_index, barf_forward, paredit_index, kill, reverse_index, unwrap_STAR_, nav_right, slurp_backward, selection_return }
