import * as squint_core from 'squint-cljs/core.js';
import { EditorState, Prec } from '@codemirror/state';
import * as view from '@codemirror/view';
import * as str from 'squint-cljs/src/squint/string.js';
import * as n from './../node.mjs';
import * as u from './../util.mjs';
import { from_to } from './../util.mjs';
var in_string_QMARK_ = (function (state, pos) {
return squint_core.contains_QMARK_(new Set(["StringContent", "String"]), n.name(n.tree(state, pos)))
});
var escaped_QMARK_ = (function (state, pos) {
return ("\\" === state.doc.slice(squint_core.max(0, (pos - 1)), pos).toString())
});
var backspace_backoff = (function (state, from, to) {
if (squint_core.truth_((function () {
 let and__27607__auto__1 = (function () {
 let G__1472 = n.node_BAR_(state, (from - 1));
if ((G__1472 == null)) {
return null} else {
return u.guard(G__1472, n.line_comment_QMARK_)}
})();
if (squint_core.truth_(and__27607__auto__1)) {
return squint_core.not(str.blank_QMARK_(u.line_content_at(state, from)))} else {
return and__27607__auto__1}
})())) {
return ({ "cursor": (from - 1) })} else {
return u.deletion(from, to)}
});
var handle_backspace = (function (p__148) {
let map__12 = p__148;
let state3 = map__12;
if (squint_core.truth_((function () {
 let and__27607__auto__4 = (1 === state3.selection.ranges.length);
if (and__27607__auto__4) {
let range5 = squint_core.get_in(state3, ["selection", "ranges", 0]);
let and__27607__auto__6 = range5.empty;
if (squint_core.truth_(and__27607__auto__6)) {
return (0 === range5.from)} else {
return and__27607__auto__6}} else {
return and__27607__auto__4}
})())) {
return null} else {
return u.update_ranges(state3, ({ "annotations": u.user_event_annotation("delete") }), (function (p__149) {
let map__78 = p__149;
let _range9 = map__78;
let head10 = squint_core.get(map__78, "head");
let empty11 = squint_core.get(map__78, "empty");
let anchor12 = squint_core.get(map__78, "anchor");
let map__1314 = from_to(head10, anchor12);
let _range15 = map__1314;
let from16 = squint_core.get(map__1314, "from");
let to17 = squint_core.get(map__1314, "to");
let node_BAR_18 = n.tree(state3).resolveInner(from16, -1);
let parent19 = node_BAR_18.parent;
if (squint_core.truth_((function () {
 let or__27578__auto__20 = squint_core.not(empty11);
if (or__27578__auto__20) {
return or__27578__auto__20} else {
let or__27578__auto__21 = ("StringContent" === n.name(n.tree(state3, from16, -1)));
if (or__27578__auto__21) {
return or__27578__auto__21} else {
let and__27607__auto__22 = parent19;
if (squint_core.truth_(and__27607__auto__22)) {
let and__27607__auto__23 = squint_core.not(n.balanced_QMARK_(parent19));
if (and__27607__auto__23) {
return n.left_edge_QMARK_(node_BAR_18)} else {
return and__27607__auto__23}} else {
return and__27607__auto__22}}}
})())) {
return u.deletion(from16, to17)} else {
if (squint_core.truth_((function () {
 let and__27607__auto__24 = n.right_edge_QMARK_(node_BAR_18);
if (squint_core.truth_(and__27607__auto__24)) {
return (from16 == n.end(parent19))} else {
return and__27607__auto__24}
})())) {
return ({ "cursor": (from16 - 1) })} else {
if (squint_core.truth_((function () {
 let and__27607__auto__25 = (function () {
 let or__27578__auto__26 = n.start_edge_QMARK_(node_BAR_18);
if (squint_core.truth_(or__27578__auto__26)) {
return or__27578__auto__26} else {
return n.same_edge_QMARK_(node_BAR_18)}
})();
if (squint_core.truth_(and__27607__auto__25)) {
return (n.start(node_BAR_18) == n.start(parent19))} else {
return and__27607__auto__25}
})())) {
if (squint_core.truth_(n.empty_QMARK_(n.up(node_BAR_18)))) {
return ({ "cursor": n.start(parent19), "changes": [from_to(n.start(parent19), n.end(parent19))] })} else {
return ({ "cursor": from16 })}} else {
if ("else") {
return backspace_backoff(state3, from16, to17)} else {
return null}}}}
}))}
});
var coll_pairs = (function (x) {
return squint_core.get(({ "(": ")", "[": "]", "{": "}", "\"": "\"" }), x)
});
var handle_open = (function (state, open) {
let close1 = coll_pairs(open);
return u.update_ranges(state, ({ "annotations": u.user_event_annotation("input") }), (function (p__150) {
let map__23 = p__150;
let from4 = squint_core.get(map__23, "from");
let to5 = squint_core.get(map__23, "to");
let head6 = squint_core.get(map__23, "head");
let anchor7 = squint_core.get(map__23, "anchor");
let empty8 = squint_core.get(map__23, "empty");
if (squint_core.truth_(in_string_QMARK_(state, from4))) {
if ((open === "\"")) {
return u.insertion(head6, "\\\"")} else {
return u.insertion(from4, to5, open)}} else {
if (squint_core.truth_(escaped_QMARK_(state, from4))) {
return u.insertion(from4, to5, open)} else {
if ("else") {
if (squint_core.truth_(empty8)) {
return ({ "changes": ({ "insert": squint_core.str(open, close1), "from": head6 }), "cursor": (head6 + squint_core.count(open)) })} else {
return ({ "changes": [({ "insert": open, "from": from4 }), ({ "insert": close1, "from": to5 })], "from-to": [(anchor7 + squint_core.count(open)), (head6 + squint_core.count(open))] })}} else {
return null}}}
}))
});
var handle_close = (function (state, key_name) {
return u.update_ranges(state, ({ "annotations": u.user_event_annotation("input") }), (function (p__151) {
let map__12 = p__151;
let _range3 = map__12;
let empty4 = squint_core.get(map__12, "empty");
let head5 = squint_core.get(map__12, "head");
let from6 = squint_core.get(map__12, "from");
let to7 = squint_core.get(map__12, "to");
if (squint_core.truth_((function () {
 let or__27578__auto__8 = in_string_QMARK_(state, from6);
if (squint_core.truth_(or__27578__auto__8)) {
return or__27578__auto__8} else {
return escaped_QMARK_(state, from6)}
})())) {
return u.insertion(from6, to7, key_name)} else {
if (squint_core.truth_(empty4)) {
let or__27578__auto__9 = (function () {
 let unbalanced10 = (function () {
 let G__15211 = n.tree(state, head5, -1);
let G__15212 = ((G__15211 == null)) ? (null) : (n.ancestors(G__15211));
let G__15213 = ((G__15212 == null)) ? (null) : (squint_core.filter(squint_core.every_pred(n.coll_QMARK_, squint_core.complement(n.balanced_QMARK_)), G__15212));
if ((G__15213 == null)) {
return null} else {
return squint_core.first(G__15213)}
})();
let closing14 = (function () {
 let G__15315 = unbalanced10;
let G__15316 = ((G__15315 == null)) ? (null) : (n.down(G__15315));
if ((G__15316 == null)) {
return null} else {
return n.closed_by(G__15316)}
})();
let pos17 = (function () {
 let G__15418 = unbalanced10;
if ((G__15418 == null)) {
return null} else {
return n.end(G__15418)}
})();
if (squint_core.truth_((function () {
 let and__27607__auto__19 = closing14;
if (squint_core.truth_(and__27607__auto__19)) {
return (closing14 === key_name)} else {
return and__27607__auto__19}
})())) {
return ({ "changes": ({ "from": pos17, "insert": closing14 }), "cursor": (pos17 + 1) })}
})();
if (squint_core.truth_(or__27578__auto__9)) {
return or__27578__auto__9} else {
let or__27578__auto__20 = (function () {
 let temp__27165__auto__21 = (function () {
 let temp__27165__auto__22 = n.terminal_cursor(n.tree(state), head5, 1);
if (squint_core.truth_(temp__27165__auto__22)) {
let cursor23 = temp__27165__auto__22;
while(true){
if (squint_core.truth_(n.right_edge_type_QMARK_(cursor23.type))) {
return n.end(cursor23)} else {
if (squint_core.truth_(cursor23.next())) {
continue;
}};break;
}
}
})();
if (squint_core.truth_(temp__27165__auto__21)) {
let close_node_end24 = temp__27165__auto__21;
return ({ "cursor": close_node_end24 })}
})();
if (squint_core.truth_(or__27578__auto__20)) {
return or__27578__auto__20} else {
return ({ "cursor": head5 })}}}}
}))
});
var handle_backspace_cmd = (function (p__155) {
let map__12 = p__155;
let view3 = map__12;
let state4 = squint_core.get(map__12, "state");
return u.dispatch_some(view3, handle_backspace(state4))
});
var handle_open_cmd = (function (key_name) {
return function (p__156) {
let map__12 = p__156;
let view3 = map__12;
let state4 = squint_core.get(map__12, "state");
return u.dispatch_some(view3, handle_open(state4, key_name))
}
});
var handle_close_cmd = (function (key_name) {
return function (p__157) {
let map__12 = p__157;
let view3 = map__12;
let state4 = squint_core.get(map__12, "state");
return u.dispatch_some(view3, handle_close(state4, key_name))
}
});
var guard_scope = (function (cmd) {
return function (p__158) {
let map__12 = p__158;
let view3 = map__12;
let state4 = squint_core.get(map__12, "state");
if (squint_core.truth_((function () {
 let or__27578__auto__5 = n.embedded_QMARK_(state4);
if (squint_core.truth_(or__27578__auto__5)) {
return or__27578__auto__5} else {
return n.within_program_QMARK_(state4)}
})())) {
return cmd(view3)} else {
return false}
}
});
var extension = (function () {
return Prec.high(view.keymap.of([({ "key": "Backspace", "run": guard_scope((function (p__159) {
let map__12 = p__159;
let view3 = map__12;
let state4 = squint_core.get(map__12, "state");
return u.dispatch_some(view3, handle_backspace(state4))
})) }), ({ "key": "(", "run": guard_scope(handle_open_cmd("(")) }), ({ "key": "[", "run": guard_scope(handle_open_cmd("[")) }), ({ "key": "{", "run": guard_scope(handle_open_cmd("{")) }), ({ "key": "\"", "run": guard_scope(handle_open_cmd("\"")) }), ({ "key": ")", "run": guard_scope(handle_close_cmd(")")) }), ({ "key": "]", "run": guard_scope(handle_close_cmd("]")) }), ({ "key": "}", "run": guard_scope(handle_close_cmd("}")) })]))
});

export { handle_backspace_cmd, handle_backspace, handle_close_cmd, backspace_backoff, escaped_QMARK_, guard_scope, handle_close, handle_open_cmd, extension, in_string_QMARK_, handle_open, coll_pairs }
