import * as squint_core from 'squint-cljs/core.js';
import * as state from '@codemirror/state';
import { StateEffect, StateField } from '@codemirror/state';
import * as view from '@codemirror/view';
import { EditorView, Decoration, keymap } from '@codemirror/view';
import { keyName } from 'w3c-keyname';
import * as u from './../util.mjs';
import * as n from './../node.mjs';
import * as str from 'squint-cljs/src/squint/string.js';
var uppermost_edge_here = (function (pos, node) {
let node1 = (function () {
 let or__27578__auto__2 = squint_core.last(squint_core.take_while(squint_core.every_pred(squint_core.complement(n.top_QMARK_), (function (_PERCENT_1) {
let or__27578__auto__3 = ((pos === n.end(_PERCENT_1)) && (n.end(_PERCENT_1) === n.end(node)));
if (squint_core.truth_(or__27578__auto__3)) {
return or__27578__auto__3} else {
((pos === n.start(_PERCENT_1)) && (n.start(_PERCENT_1) === n.start(node)))}
})), squint_core.iterate(n.up, node)));
if (squint_core.truth_(or__27578__auto__2)) {
return or__27578__auto__2} else {
return node}
})();
if (("Discard" === n.name(node1))) {
return squint_core.last(n.children(node1))} else {
return node1}
});
var main_selection = (function (state) {
return squint_core.get_in((function () {
 let parent__39__auto__1 = squint_core.get_in(state, ["selection"]);
let f__40__auto__2 = squint_core.get(parent__39__auto__1, "asSingle");
return f__40__auto__2.call(parent__39__auto__1)
})(), ["ranges", 0])
});
var node_at_cursor = (function () {
 let f164 = (function (var_args) {
let G__1671 = arguments.length;
switch (G__1671) {case 1:
return f164.cljs$core$IFn$_invoke$arity$1((arguments[0]))
break;
case 2:
return f164.cljs$core$IFn$_invoke$arity$2((arguments[0]), (arguments[1]))
break;
default:
throw new Error(squint_core.str("Invalid arity: ", squint_core.alength(arguments)))}
});
f164.cljs$core$IFn$_invoke$arity$1 = (function (state) {
return node_at_cursor(state, squint_core.get(main_selection(state), "from"))
});
f164.cljs$core$IFn$_invoke$arity$2 = (function (state, from) {
let G__1683 = n.nearest_touching(state, from, -1);
let G__1684 = ((G__1683 == null)) ? (null) : ((function (_PERCENT_1) {
if (squint_core.truth_((function () {
 let or__27578__auto__5 = n.terminal_type_QMARK_(n.type(_PERCENT_1));
if (squint_core.truth_(or__27578__auto__5)) {
return or__27578__auto__5} else {
let or__27578__auto__6 = (n.start(_PERCENT_1) <= from);
if (or__27578__auto__6) {
return or__27578__auto__6} else {
return (n.end(_PERCENT_1) <= from)}}
})())) {
let G__1697 = _PERCENT_1;
if (squint_core.truth_((function () {
 let or__27578__auto__8 = n.top_QMARK_(_PERCENT_1);
if (squint_core.truth_(or__27578__auto__8)) {
return or__27578__auto__8} else {
let and__27607__auto__9 = squint_core.not(n.terminal_type_QMARK_(n.type(_PERCENT_1)));
if (and__27607__auto__9) {
((n.start(_PERCENT_1) < from) && (from < n.end(_PERCENT_1)))} else {
return and__27607__auto__9}}
})())) {
return squint_core.first(n.children(G__1697, from, -1))} else {
return G__1697}}
})(G__1683));
let G__16810 = ((G__1684 == null)) ? (null) : (uppermost_edge_here(from, G__1684));
if ((G__16810 == null)) {
return null} else {
return n.balanced_range(state, G__16810)}
});
f164.cljs$lang$maxFixedArity = 2;
return f164
})();
var top_level_node = (function (state) {
return squint_core.last(squint_core.take_while(squint_core.every_pred(squint_core.identity, squint_core.complement(n.top_QMARK_)), squint_core.iterate(n.up, n.nearest_touching(state, squint_core.get(main_selection(state), "from"), -1))))
});
var modifier_effect = StateEffect.define();
var modifier_field = StateField.define(({ "create": squint_core.constantly(({  })), "update": (function (value, tr) {
let or__27578__auto__1 = (function () {
 let G__1702 = squint_core.first(squint_core.filter((function (_PERCENT_1) {
return _PERCENT_1.is(modifier_effect)
}), tr.effects));
if ((G__1702 == null)) {
return null} else {
return squint_core.get(G__1702, "value")}
})();
if (squint_core.truth_(or__27578__auto__1)) {
return or__27578__auto__1} else {
return value}
}) }));
var get_modifier_field = (function (state) {
return state.field(modifier_field)
});
var set_modifier_field_BANG_ = (function (p__171, value) {
let map__12 = p__171;
let _view3 = map__12;
let dispatch4 = squint_core.get(map__12, "dispatch");
return dispatch4(({ "effects": modifier_effect.of(value), "userEvent": "evalregion" }))
});
var mark = (function (spec, p__172) {
let map__12 = p__172;
let from3 = squint_core.get(map__12, "from");
let to4 = squint_core.get(map__12, "to");
return Decoration.mark(spec).range(from3, to4)
});
var single_mark = (function (spec, range) {
return Decoration.set([mark(spec, range)])
});
var mark_spec = ({ "attributes": ({ "style": "background-color: rgba(0, 243, 255, 0.14);" }) });
var mark_spec_highlight = ({ "attributes": ({ "style": "background-color: rgba(0, 243, 255, 0.35);" }) });
var cursor_range = (function (state) {
if (squint_core.truth_(state.selection.main.empty)) {
return node_at_cursor(state)} else {
return state.selection.main}
});
var region_field = StateField.define(({ "create": squint_core.constantly(Decoration.none), "update": (function (_value, p__173) {
let map__12 = p__173;
let state3 = squint_core.get(map__12, "state");
let map__45 = get_modifier_field(state3);
let field6 = map__45;
let Shift7 = squint_core.get(map__45, "Shift");
let Enter8 = squint_core.get(map__45, "Enter");
let modifier9 = squint_core.get(map__45, "modifier");
let modifier_pressed_QMARK_10 = squint_core.get(field6, modifier9);
let spec11 = (squint_core.truth_(Enter8)) ? (mark_spec_highlight) : (mark_spec);
let temp__27139__auto__12 = (squint_core.truth_((function () {
 let or__27578__auto__13 = n.embedded_QMARK_(state3);
if (squint_core.truth_(or__27578__auto__13)) {
return or__27578__auto__13} else {
return n.within_program_QMARK_(state3)}
})())) ? ((squint_core.truth_((function () {
 let and__27607__auto__14 = modifier_pressed_QMARK_10;
if (squint_core.truth_(and__27607__auto__14)) {
return Shift7} else {
return and__27607__auto__14}
})())) ? (top_level_node(state3)) : ((squint_core.truth_(modifier_pressed_QMARK_10)) ? ((function () {
 let or__27578__auto__15 = u.guard(main_selection(state3), (function (_PERCENT_1) {
return squint_core.not(squint_core.get(_PERCENT_1, "empty"))
}));
if (squint_core.truth_(or__27578__auto__15)) {
return or__27578__auto__15} else {
return cursor_range(state3)}
})()) : (null))) : (null);
if ((temp__27139__auto__12 == null)) {
return Decoration.none} else {
let range16 = temp__27139__auto__12;
return single_mark(spec11, range16)}
}) }));
var get_region_field = (function (state) {
return state.field(region_field)
});
var current_range = (function (state) {
let or__27578__auto__1 = (function () {
 let G__1742 = get_region_field(state);
let G__1743 = ((G__1742 == null)) ? (null) : (G__1742.iter());
if ((G__1743 == null)) {
return null} else {
return u.guard(G__1743, (function (_PERCENT_1) {
return squint_core.get(_PERCENT_1, "value")
}))}
})();
if (squint_core.truth_(or__27578__auto__1)) {
return or__27578__auto__1} else {
return state.selection.main}
});
var modifier_extension = (function (modifier) {
let handle_enter1 = (function handle_enter (p__175) {
let map__23 = p__175;
let view4 = map__23;
let state5 = squint_core.get(map__23, "state");
set_modifier_field_BANG_(view4, squint_core.assoc(get_modifier_field(state5), "Enter", true));
return null
});
let handle_key_event6 = (function (p__176, p__177) {
let map__79 = p__176;
let event10 = map__79;
let altKey11 = squint_core.get(map__79, "altKey");
let shiftKey12 = squint_core.get(map__79, "shiftKey");
let metaKey13 = squint_core.get(map__79, "metaKey");
let controlKey14 = squint_core.get(map__79, "controlKey");
let type15 = squint_core.get(map__79, "type");
let map__816 = p__177;
let view17 = map__816;
let state18 = squint_core.get(map__816, "state");
let prev19 = get_modifier_field(state18);
let next20 = (function () {
 let G__17821 = ({ "modifier": modifier });
let G__17822 = (squint_core.truth_(altKey11)) ? (squint_core.assoc(G__17821, "Alt", true)) : (G__17821);
let G__17823 = (squint_core.truth_(shiftKey12)) ? (squint_core.assoc(G__17822, "Shift", true)) : (G__17822);
let G__17824 = (squint_core.truth_(metaKey13)) ? (squint_core.assoc(G__17823, "Meta", true)) : (G__17823);
let G__17825 = (squint_core.truth_(controlKey14)) ? (squint_core.assoc(G__17824, "Control", true)) : (G__17824);
if (squint_core.truth_((function () {
 let and__27607__auto__26 = ("keydown" === type15);
if (and__27607__auto__26) {
return ("Enter" === keyName(event10))} else {
return and__27607__auto__26}
})())) {
return squint_core.assoc(G__17825, "Enter", true)} else {
return G__17825}
})();
if ((prev19 !== next20)) {
set_modifier_field_BANG_(view17, next20)};
return false
});
let handle_backspace27 = (function (p__179) {
let map__2829 = p__179;
let _view30 = map__2829;
let state31 = squint_core.get(map__2829, "state");
let dispatch32 = squint_core.get(map__2829, "dispatch");
let map__3334 = current_range(state31);
let from35 = squint_core.get(map__3334, "from");
let to36 = squint_core.get(map__3334, "to");
if ((from35 !== to36)) {
dispatch32(({ "changes": ({ "from": from35, "to": to36, "insert": "" }), "annotations": u.user_event_annotation("delete") }))};
return true
});
return [modifier_field, keymap.of([({ "key": squint_core.str(modifier, "-Enter"), "shift": handle_enter1, "run": handle_enter1 }), ({ "key": squint_core.str(modifier, "-Backspace"), "run": handle_backspace27, "shift": handle_backspace27 })]), view.EditorView.domEventHandlers(({ "keydown": handle_key_event6, "keyup": handle_key_event6 }))]
});
var extension = (function (p__180) {
let map__12 = p__180;
let modifier3 = squint_core.get(map__12, "modifier", "Meta");
return [modifier_extension(modifier3), region_field, EditorView.decorations.from(region_field)]
});
var cursor_node_string = (function (state) {
return u.guard((function () {
 let G__1811 = node_at_cursor(state);
if ((G__1811 == null)) {
return null} else {
return u.range_str(state, G__1811)}
})(), squint_core.complement(str.blank_QMARK_))
});
var top_level_string = (function (state) {
return u.guard((function () {
 let G__1821 = top_level_node(state);
if ((G__1821 == null)) {
return null} else {
return u.range_str(state, G__1821)}
})(), squint_core.complement(str.blank_QMARK_))
});

export { top_level_node, current_range, set_modifier_field_BANG_, cursor_range, modifier_field, mark_spec_highlight, modifier_extension, extension, node_at_cursor, region_field, get_modifier_field, get_region_field, main_selection, mark_spec, mark, top_level_string, single_mark, uppermost_edge_here, cursor_node_string, modifier_effect }
