import * as squint_core from 'squint-cljs/core.js';
import { StateField } from '@codemirror/state';
import { EditorView, Decoration } from '@codemirror/view';
import * as n from './../node.mjs';
import * as u from './../util.mjs';
var base_theme = EditorView.baseTheme(({ "$matchingBracket": ({ "color": "#0b0" }), "$nonmatchingBracket": ({ "color": "#a22" }) }));
var matching_mark = Decoration.mark(squint_core.js_obj("class", "cm-matchingBracket"));
var nonmatching_mark = Decoration.mark(squint_core.js_obj("class", "cm-nonmatchingBracket"));
var mark_node = (function (node, mark) {
return mark.range(n.start(node), n.end(node))
});
var state = StateField.define(({ "create": squint_core.constantly(Decoration.none), "update": (function (deco, p__206) {
let map__12 = p__206;
let tr3 = map__12;
let state4 = squint_core.get(map__12, "state");
let docChanged5 = squint_core.get(map__12, "docChanged");
let selection6 = squint_core.get(map__12, "selection");
if (squint_core.truth_((function () {
 let or__27578__auto__7 = docChanged5;
if (squint_core.truth_(or__27578__auto__7)) {
return or__27578__auto__7} else {
return selection6}
})())) {
let decos8 = squint_core.reduce((function (out, p__207) {
let map__910 = p__207;
let head11 = squint_core.get(map__910, "head");
let empty12 = squint_core.get(map__910, "empty");
let or__27578__auto__13 = (function () {
 let temp__27165__auto__14 = (function () {
 let and__27607__auto__15 = empty12;
if (squint_core.truth_(and__27607__auto__15)) {
return squint_core.first(squint_core.filter(squint_core.some_fn(n.start_edge_QMARK_, n.end_edge_QMARK_), [n.tree(state4, head11, -1), n.tree(state4, head11, 1)]))} else {
return and__27607__auto__15}
})();
if (squint_core.truth_(temp__27165__auto__14)) {
let bracket16 = temp__27165__auto__14;
let temp__27107__auto__17 = (squint_core.truth_((function () {
 let and__27607__auto__18 = n.start_edge_QMARK_(bracket16);
if (squint_core.truth_(and__27607__auto__18)) {
return (n.start(bracket16) === n.start(n.up(bracket16)))} else {
return and__27607__auto__18}
})())) ? (u.guard(n.down_last(n.up(bracket16)), (function (_PERCENT_1) {
return (n.name(_PERCENT_1) === n.closed_by(bracket16))
}))) : ((squint_core.truth_((function () {
 let and__27607__auto__19 = n.end_edge_QMARK_(bracket16);
if (squint_core.truth_(and__27607__auto__19)) {
return (n.end(bracket16) === n.end(n.up(bracket16)))} else {
return and__27607__auto__19}
})())) ? (u.guard(n.down(n.up(bracket16)), (function (_PERCENT_1) {
return (n.name(_PERCENT_1) === n.opened_by(bracket16))
}))) : (null));
if (squint_core.truth_(temp__27107__auto__17)) {
let other_bracket20 = temp__27107__auto__17;
return squint_core.conj(out, mark_node(bracket16, matching_mark), mark_node(other_bracket20, matching_mark))} else {
return squint_core.conj(out, mark_node(bracket16, nonmatching_mark))}}
})();
if (squint_core.truth_(or__27578__auto__13)) {
return or__27578__auto__13} else {
let or__27578__auto__21 = (function () {
 let temp__27165__auto__22 = (function () {
 let and__27607__auto__23 = squint_core.not(n.closest(n.tree(state4, head11), n.string_QMARK_));
if (and__27607__auto__23) {
return squint_core.contains_QMARK_(new Set(["]", ")", "}"]), tr3.state.doc.slice(head11, (head11 + 1)).toString())} else {
return and__27607__auto__23}
})();
if (squint_core.truth_(temp__27165__auto__22)) {
let _unparsed_bracket24 = temp__27165__auto__22;
return squint_core.conj(out, mark_node(n.from_to(head11, (head11 + 1)), nonmatching_mark))}
})();
if (squint_core.truth_(or__27578__auto__21)) {
return or__27578__auto__21} else {
return out}}
}), [], tr3.state.selection.ranges);
return Decoration.set(squint_core.into_array(decos8), true)} else {
return deco}
}) }));
var extension = (function () {
return [base_theme, state, EditorView.decorations.from(state)]
});

export { base_theme, matching_mark, nonmatching_mark, mark_node, state, extension }
