import * as squint_core from 'squint-cljs/core.js';
import { EditorSelection, StateEffect, Transaction } from '@codemirror/state';
import * as sel from './selections.mjs';
var node_js_QMARK_ = squint_core.some_QMARK_(globalThis.process);
var user_event_annotation = (function (event_name) {
return Transaction.userEvent.of(event_name)
});
var get_user_event_annotation = (function (tr) {
return tr.annotation(Transaction.userEvent)
});
var guard = (function (x, f) {
if (squint_core.truth_(f(x))) {
return x}
});
var from_to = (function (p1, p2) {
if ((p1 > p2)) {
return ({ "from": p2, "to": p1 })} else {
return ({ "from": p1, "to": p2 })}
});
var dispatch_some = (function (view, tr) {
if (squint_core.truth_(tr)) {
view.dispatch(tr);
return true} else {
return false}
});
var insertion = (function () {
 let f289 = (function (var_args) {
let G__2921 = arguments.length;
switch (G__2921) {case 2:
return f289.cljs$core$IFn$_invoke$arity$2((arguments[0]), (arguments[1]))
break;
case 3:
return f289.cljs$core$IFn$_invoke$arity$3((arguments[0]), (arguments[1]), (arguments[2]))
break;
default:
throw new Error(squint_core.str("Invalid arity: ", squint_core.alength(arguments)))}
});
f289.cljs$core$IFn$_invoke$arity$2 = (function (from, s) {
return insertion(from, from, s)
});
f289.cljs$core$IFn$_invoke$arity$3 = (function (from, to, s) {
return ({ "changes": ({ "insert": s, "from": from, "to": to }), "cursor": (from + squint_core.count(s)) })
});
f289.cljs$lang$maxFixedArity = 3;
return f289
})();
var deletion = (function () {
 let f293 = (function (var_args) {
let G__2961 = arguments.length;
switch (G__2961) {case 1:
return f293.cljs$core$IFn$_invoke$arity$1((arguments[0]))
break;
case 2:
return f293.cljs$core$IFn$_invoke$arity$2((arguments[0]), (arguments[1]))
break;
default:
throw new Error(squint_core.str("Invalid arity: ", squint_core.alength(arguments)))}
});
f293.cljs$core$IFn$_invoke$arity$1 = (function (from) {
return deletion(squint_core.max(0, (from - 1)), from)
});
f293.cljs$core$IFn$_invoke$arity$2 = (function (from, to) {
let from3 = ((from === to)) ? (squint_core.max(0, (from - 1))) : (from);
return ({ "cursor": from3, "changes": ({ "from": from3, "to": to }) })
});
f293.cljs$lang$maxFixedArity = 2;
return f293
})();
var line_content_at = (function (state, from) {
return (function () {
 let parent__39__auto__1 = squint_core.get_in(state, ["doc"]);
let f__40__auto__2 = squint_core.get(parent__39__auto__1, "lineAt");
return f__40__auto__2.call(parent__39__auto__1, from)
})().slice()
});
var map_cursor = (function (original_range, state, update_map) {
if (squint_core.truth_(squint_core.map_QMARK_(update_map))) {
null} else {
throw new Error("Assert failed: (map? update-map)")};
let map__12 = guard(update_map, squint_core.map_QMARK_);
let mapped3 = squint_core.get(map__12, "cursor/mapped");
let cursor4 = squint_core.get(map__12, "cursor");
let from_to5 = squint_core.get(map__12, "from-to");
let range6 = squint_core.get(map__12, "range");
let changes7 = squint_core.get(map__12, "changes");
let change_desc8 = (squint_core.truth_(changes7)) ? (state.changes(changes7)) : (null);
let G__2979 = ({ "range": (function () {
 let or__27578__auto__10 = range6;
if (squint_core.truth_(or__27578__auto__10)) {
return or__27578__auto__10} else {
let or__27578__auto__11 = (squint_core.truth_(mapped3)) ? (sel.cursor(change_desc8.mapPos(mapped3))) : ((squint_core.truth_(cursor4)) ? (sel.cursor(cursor4)) : ((squint_core.truth_(from_to5)) ? (sel.range(from_to5(0), from_to5(1))) : (null)));
if (squint_core.truth_(or__27578__auto__11)) {
return or__27578__auto__11} else {
return original_range}}
})() });
if (squint_core.truth_(change_desc8)) {
G__2979.changes = change_desc8;
return G__2979} else {
return G__2979}
});
var update_ranges = (function () {
 let f298 = (function (var_args) {
let G__3011 = arguments.length;
switch (G__3011) {case 2:
return f298.cljs$core$IFn$_invoke$arity$2((arguments[0]), (arguments[1]))
break;
case 3:
return f298.cljs$core$IFn$_invoke$arity$3((arguments[0]), (arguments[1]), (arguments[2]))
break;
default:
throw new Error(squint_core.str("Invalid arity: ", squint_core.alength(arguments)))}
});
f298.cljs$core$IFn$_invoke$arity$2 = (function (state, f) {
return update_ranges(state, null, f)
});
f298.cljs$core$IFn$_invoke$arity$3 = (function (state, tr_specs, f) {
return state.update((function (_PERCENT_1) {
return Object.assign(_PERCENT_1, tr_specs)
})(state.changeByRange((function (range) {
let or__27578__auto__3 = (function () {
 let temp__27298__auto__4 = f(range);
if ((temp__27298__auto__4 == null)) {
return null} else {
let result5 = temp__27298__auto__4;
return map_cursor(range, state, result5)}
})();
if (squint_core.truth_(or__27578__auto__3)) {
return or__27578__auto__3} else {
return ({ "range": range })}
}))))
});
f298.cljs$lang$maxFixedArity = 3;
return f298
})();
var dispatch_changes = (function (state, dispatch, changes) {
if (squint_core.truth_(changes.empty)) {
return null} else {
return dispatch(state.update(({ "changes": changes })))}
});
var update_lines = (function () {
 let f302 = (function (var_args) {
let args3031 = [];
let len__27417__auto__2 = arguments.length;
let i3043 = 0;
while(true){
if ((i3043 < len__27417__auto__2)) {
args3031.push((arguments[i3043]));
let G__4 = (i3043 + 1);
i3043 = G__4;
continue;
};break;
}
;
let argseq__27653__auto__5 = ((2 < args3031.length)) ? (args3031.slice(2)) : (null);
return f302.cljs$core$IFn$_invoke$arity$variadic((arguments[0]), (arguments[1]), argseq__27653__auto__5)
});
f302.cljs$core$IFn$_invoke$arity$variadic = (function (state, f, p__308) {
let vec__610 = p__308;
let map__911 = squint_core.nth(vec__610, 0, null);
let from12 = squint_core.get(map__911, "from", 0);
let to13 = squint_core.get(map__911, "to");
let spec14 = squint_core.get(map__911, "spec");
let iterator15 = state.doc.iter();
let result16 = iterator15.next();
let changes17 = [];
let from_pos18 = from12;
let line_num19 = 1;
while(true){
let map__2021 = result16;
let done22 = squint_core.get(map__2021, "done");
let lineBreak23 = squint_core.get(map__2021, "lineBreak");
let value24 = squint_core.get(map__2021, "value");
if (squint_core.truth_((function () {
 let or__27578__auto__25 = done22;
if (squint_core.truth_(or__27578__auto__25)) {
return or__27578__auto__25} else {
return (from12 > to13)}
})())) {
return state.update(Object.assign(({ "changes": state.changes(changes17) }), spec14))} else {
let G__26 = iterator15.next();
let G__27 = (function () {
 let temp__27107__auto__28 = (function () {
 let and__27607__auto__29 = squint_core.not(lineBreak23);
if (and__27607__auto__29) {
return f(from_pos18, value24, line_num19)} else {
return and__27607__auto__29}
})();
if (squint_core.truth_(temp__27107__auto__28)) {
let change30 = temp__27107__auto__28;
let G__30931 = changes17;
G__30931.push(change30);
return G__30931} else {
return changes17}
})();
let G__32 = (from_pos18 + squint_core.count(value24));
let G__33 = (function () {
 let G__31034 = line_num19;
if (squint_core.truth_(lineBreak23)) {
return (G__31034 + 1)} else {
return G__31034}
})();
result16 = G__26;
changes17 = G__27;
from_pos18 = G__32;
line_num19 = G__33;
continue;
};break;
}

});
f302.cljs$lang$maxFixedArity = 2;
f302.cljs$lang$applyTo = (function (seq305) {
let G__30635 = squint_core.first(seq305);
let seq30536 = squint_core.next(seq305);
let G__30737 = squint_core.first(seq30536);
let seq30538 = squint_core.next(seq30536);
let self__27434__auto__39 = this;
return self__27434__auto__39.cljs$core$IFn$_invoke$arity$variadic(G__30635, G__30737, seq30538)
});
return f302
})();
var update_selected_lines = (function (state, f) {
let at_line1 = squint_core.atom(-1);
let doc2 = state.doc;
return state.changeByRange((function (p__311) {
let map__34 = p__311;
let range5 = map__34;
let from6 = squint_core.get(map__34, "from");
let to7 = squint_core.get(map__34, "to");
let anchor8 = squint_core.get(map__34, "anchor");
let head9 = squint_core.get(map__34, "head");
let changes10 = [];
let line11 = doc2.lineAt(from6);
while(true){
let map__1213 = line11;
let line_number14 = squint_core.get(map__1213, "number");
let line_to15 = squint_core.get(map__1213, "to");
if ((line11.number > squint_core.deref(at_line1))) {
squint_core.reset_BANG_(at_line1, line_number14);
f(line11, changes10, range5)};
let temp__27107__auto__16 = (function () {
 let and__27607__auto__17 = (to7 > line_to15);
if (and__27607__auto__17) {
return guard(doc2.lineAt((line_to15 + 1)), (function (_PERCENT_1) {
return (_PERCENT_1.number > line_number14)
}))} else {
return and__27607__auto__17}
})();
if (squint_core.truth_(temp__27107__auto__16)) {
let next_line18 = temp__27107__auto__16;
let G__19 = next_line18;
line11 = G__19;
continue;
} else {
let change_set20 = state.changes(changes10);
return ({ "changes": changes10, "range": EditorSelection.range(change_set20.mapPos(anchor8, 1), change_set20.mapPos(head9, 1)) })};break;
}

}))
});
var iter_changed_lines = (function (p__312, f) {
let map__13 = p__312;
let tr4 = map__13;
let map__25 = squint_core.get(map__13, "state");
let state6 = map__25;
let doc7 = squint_core.get(map__25, "doc");
let changes8 = squint_core.get(map__13, "changes");
let effects9 = squint_core.get(map__13, "effects");
let selection10 = squint_core.get(map__13, "selection");
let at_line11 = squint_core.atom(-1);
let next_changes12 = [];
let _13 = changes8.iterChanges((function (_from_a, _to_a, from_b, to_b, _inserted) {
let map__1415 = doc7.lineAt(from_b);
let line16 = map__1415;
let line_number17 = squint_core.get(map__1415, "number");
let line_to18 = squint_core.get(map__1415, "to");
let line19 = line16;
while(true){
if ((line_number17 > squint_core.deref(at_line11))) {
squint_core.reset_BANG_(at_line11, line_number17);
f(line19, next_changes12)};
if ((to_b <= line_to18)) {
return null} else {
let next_line20 = doc7.lineAt((line_to18 + 1));
if (squint_core.truth_((function () {
 let and__27607__auto__21 = next_line20;
if (squint_core.truth_(and__27607__auto__21)) {
return (next_line20.number > line19.number)} else {
return and__27607__auto__21}
})())) {
let G__22 = next_line20;
line19 = G__22;
continue;
}};break;
}

}));
let next_changeset23 = state6.changes(next_changes12);
if (squint_core.truth_(squint_core.seq(next_changes12))) {
let G__31324 = squint_core.assoc_BANG_(squint_core.select_keys(tr4, ["annotations", "scrollIntoView", "reconfigure"]), "changes", changes8.compose(next_changeset23));
let G__31325 = (squint_core.truth_(selection10)) ? (squint_core.assoc_BANG_(G__31324, "selection", state6.selection.map(next_changeset23))) : (G__31324);
if (squint_core.truth_(effects9)) {
return squint_core.assoc_BANG_(G__31325, "effects", StateEffect.mapEffects(effects9, next_changeset23))} else {
return G__31325}} else {
return tr4}
});
var something_selected_QMARK_ = (function (p__314) {
let map__13 = p__314;
let map__24 = squint_core.get(map__13, "selection");
let ranges5 = squint_core.get(map__24, "ranges");
return squint_core.not(squint_core.every_QMARK_((function (_PERCENT_1) {
return _PERCENT_1.empty
}), ranges5))
});
var range_str = (function (state, p__315) {
let map__12 = p__315;
let _selection3 = map__12;
let from4 = squint_core.get(map__12, "from");
let to5 = squint_core.get(map__12, "to");
return squint_core.str((function () {
 let parent__39__auto__6 = squint_core.get_in(state, ["doc"]);
let f__40__auto__7 = squint_core.get(parent__39__auto__6, "slice");
return f__40__auto__7.call(parent__39__auto__6, from4, to5)
})())
});

export { dispatch_some, guard, node_js_QMARK_, dispatch_changes, insertion, deletion, line_content_at, update_selected_lines, map_cursor, get_user_event_annotation, user_event_annotation, update_ranges, from_to, iter_changed_lines, update_lines, range_str, something_selected_QMARK_ }
